 /*
 * file      : build.h
 * project   : BaseBuild
 * with      : Gtk-2
 *
 * copyright : (C) 2010 - 2012 by Claude Bulin
 *
 * BaseBuild - Creation d'une base de programmation en langage C de type GNU avec les autotools
 * GNU General Public License
 * 
 * This file is part of BASEBUILD.
 * 
 * BASEBUILD is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 * 
 * BASEBUILD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with BASEBUILD.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef __build_h__
#define __build_h__ 1


typedef struct {
	
	gchar	*PathName;				// Chemin complet
	gchar	*Name;					// Nom du dossier source
	gchar	*Exec;					// Nom de l'executable dans le dossier source
	GString	*GstrSrcMakefileAm;			// Buffer pour src/Makefile.am
	
} VAR_BUILD_SRC;

typedef struct {
	
	gchar		*PathProject;			// Path du projet
	gchar		*NameProject;			// Nom du projet
	gchar		*VersionProject;		// Version du projet
	gchar		*NewPathName;			// Path + Nom + Version du projet
	
	GList		*ListPathSrc;			// GLIST pour VAR_BUILD_SRC
	gchar		*PathNameLib;			// Path dossier Lib
	gchar		*NameLib;			// Nom dossier Lib
	gchar		*PathNameMan;			// Path dossier Man
	gchar		*PathNamePo;			// Path dossier Po
	gchar		*PathNamePixmaps;		// Path dossier Pixmaps
	gchar		*PathNameMenu;			// Path dossier Menu
	gchar		*PathNameMime;			// Path dossier Mime
	gchar		*PathNameGlade;			// Path dossier Glade
		
	gboolean	Bool_lib_gtk;			// checkbutton_lib_gtk
	gboolean	Bool_lib_glib;			// checkbutton_lib_glib	
	
	gboolean	Bool_dossier_po;		// checkbutton_dossier_po
	gboolean	Bool_dossier_manpage;		// checkbutton_dossier_manpage
	gboolean	Bool_dossier_lib_statique;	// checkbutton_dossier_lib_statique
	gboolean	Bool_dossier_pixmaps;		// checkbutton_dossier_pixmaps
	gboolean	Bool_dossier_menu;		// checkbutton_dossier_menu
	gboolean	Bool_dossier_mime;		// checkbutton_dossier_mime
	gboolean	Bool_dossier_glade;		// = Bool_lib_gtk
	
	gboolean	Bool_import_glade_file;		// checkbutton_lib_gtk = TRUE && checkbutton_choice_glade_file = TRUE
	gboolean	Bool_import_glade_translate;	// = Bool_import_glade_file && translate = TRUE
		
} VAR_BUILD;

//
// BUILD.C
//

void	build_clicked (void);
void	build_files (void);
void	build_remove (void);
void	build_view_struct (void);
gchar	*build_get_name_project (void);
gchar	*build_get_dest_pathnamefile_glade (void);

//
// BUILD_WRITE.C
//

void	BuildWrite_file( gchar *Path, gchar *Name, gchar *Ext, gchar *buffer );
void	BuildWrite_makefile_am( gchar *Path, gchar *Name, gchar *Ext );
void	BuildWrite_lib_makefile_am( gchar *Path, gchar *Name, gchar *Ext );
void	BuildWrite_LIB_C_file( gchar *Path, gchar *Name, gchar *Ext );
void	BuildWrite_LIB_H_file( gchar *Path, gchar *Name, gchar *Ext );
void	BuildWrite_glade_makefile_am( gchar *Path, gchar *Name, gchar *Ext );
void	BuildWrite_GLADE_file( gchar *Path, gchar *Name, gchar *Ext );
void	BuildWrite_src_makefile_am( gchar *Path, gchar *Name, gchar *Ext, VAR_BUILD_SRC *VarBuildSrc );
void	BuildWrite_SRC_C_file( gchar *Path, gchar *Name, gchar *Ext, VAR_BUILD_SRC *VarBuildSrc );
void	BuildWrite_GLOBAL_H_file( gchar *Path, gchar *Name, gchar *Ext );
void	BuildWrite_SRC_TRANSLATE_C_file( gchar *Path, gchar *Name, gchar *Ext, VAR_BUILD_SRC *VarBuildSrc );
void	BuildWrite_man_makefile_am( gchar *Path, gchar *Name, gchar *Ext );
void	BuildWrite_MAN_file (void);
void	BuildWrite_pixmaps_makefile_am( gchar *Path, gchar *Name, gchar *Ext );
void	BuildWrite_PIXMAPS_file( void );
void	BuildWrite_menu_makefile_am( gchar *Path, gchar *Name, gchar *Ext );
void	BuildWrite_MENU_file( gchar *Path, gchar *Name, gchar *Ext );
void	BuildWrite_mime_makefile_am( gchar *Path, gchar *Name, gchar *Ext );
void	BuildWrite_MIME_file( gchar *Path, gchar *Name, gchar *Ext );
void	BuildWrite_configure_in( gchar *Path, gchar *Name, gchar *Ext );
void	BuildWrite_GETTEXTIZE_file( void );
void	BuildWrite_PO_file( gchar *PathNamaneFile_PO );
void	BuildWrite_file( gchar *Path, gchar *Name, gchar *Ext, gchar *buffer );


#endif

