 /*
 * file      : global.h
 * project   : BaseBuild
 * with      : Gtk-2
 *
 * copyright : (C) 2010 - 2012 by Claude Bulin
 *
 * BaseBuild - Creation d'une base de programmation en langage C de type GNU avec les autotools
 * GNU General Public License
 * 
 * This file is part of BASEBUILD.
 * 
 * BASEBUILD is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 * 
 * BASEBUILD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with BASEBUILD.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __global_h__
#define __global_h__ 1

extern	GtkBuilder	*GtkBuilderProjet;
extern	GtkWidget	*WindMain;

#define GLADE_GET_OBJECT(OBJ) gtk_builder_get_object (GtkBuilderProjet, OBJ)

/*
*---------------------------------------------------------------------------
* DEBUG
*---------------------------------------------------------------------------
*/
#define PRINTINT(str,num)	if( TRUE == OptionsCommandLine.BoolVerboseMode ) g_print ("%s = %d\n", str, num)
#define PRINTBOOL(str,bool)	if( TRUE == OptionsCommandLine.BoolVerboseMode ) g_print ("%s = %s\n", str, bool == TRUE ? "TRUE" : "FALSE")
#define PRINT_FUNC_LF()		if( TRUE == OptionsCommandLine.BoolVerboseMode ) g_print ("%s :: %s (line = %d) \n", __FILE__, __FUNCTION__, __LINE__)
#define PRINT(str)		if( TRUE == OptionsCommandLine.BoolVerboseMode ) g_print ("%s :: %s(line = %d)\n	%s\n", __FILE__, __FUNCTION__, __LINE__, str)

// /usr/include/gtk-2.0/gdk/gdkkeysyms.h
typedef struct {
	
	gboolean	BoolGDKPress;		//
	gboolean	BoolGDK_Control_L_R;	// 
	gboolean	BoolGDK_Control_A;	// 
	
	gboolean	BoolGDK_Shift_L_R;	// 
	gboolean	BoolGDK_Shift_L;	// 
	gboolean	BoolGDK_Shift_R;	// 
	
	guint		keyval;			// 
} KEYS;

extern KEYS keys;

/*
*---------------------------------------------------------------------------
* SUPPORT
*---------------------------------------------------------------------------
*/
#ifndef GLADE_HOOKUP_OBJECT
#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)
#endif

#ifndef GLADE_HOOKUP_OBJECT_NO_REF
#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)
#endif


// COMBOBOX FOR: Config.ComboboxChoiceGlade
// 
typedef enum {
	CHOICE_GLADE_FILE_NONE,		// 0
	CHOICE_GLADE_FILE_DEFAULT,	// 1
	CHOICE_GLADE_FILE_OK		// 2
} CHOICE_GLADE_FILE;


#endif

