 /*
 * file      : callbacks.c
 * project   : BaseBuild
 * with      : Gtk-2
 *
 * copyright : (C) 2010 - 2012 by Claude Bulin
 *
 * BaseBuild - Creation d'une base de programmation en langage C de type GNU avec les autotools
 * GNU General Public License
 * 
 * This file is part of BASEBUILD.
 * 
 * BASEBUILD is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 * 
 * BASEBUILD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with BASEBUILD.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifdef HAVE_CONFIG_H
	#include "../config.h"
#endif

#ifdef ENABLE_NLS
	#include <libintl.h>
	#define _(String) gettext (String)
#endif

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <getopt.h>
#include <unistd.h>	// getuid()

#ifdef ENABLE_STATIC_LIBRARY
	#include "../lib_basebuild/libbasebuild.h"
#endif

#include "configuser.h"
#include "win_info.h"
#include "proto.h"
#include "win_about.h"
#include "callbacks.h"
#include "global.h"


GtkBuilder	*GtkBuilderProjet = NULL;
GtkWidget	*WindMain = NULL;

KEYS keys = {
	FALSE,		// gboolean	BoolGDKPress
	FALSE,		// gboolean	BoolGDK_Control_L_R
	FALSE,		// gboolean	BoolGDK_Control_A
	FALSE,		// gboolean	BoolGDK_Shift_L_R
	FALSE,		// gboolean	BoolGDK_Shift_L
	FALSE,		// gboolean	BoolGDK_Shift_R
	0		// guint	keyval
};


// -RECUPERATION DES DATAS
// -SAUVEGARDE DES DATAS
// 
void remove_memory_apply (void)
{
	g_print ("\n--------------------------------------------------\n");
	PRINT_FUNC_LF();
	g_print ("--------------------------------------------------\n");
	
	g_print ("Recuperation position et taille de la fenetre\n");
	gdk_window_get_root_origin (WindMain->window, &Config.WinPos_X, &Config.WinPos_Y);
	gdk_window_get_size (WindMain->window, &Config.WinWidth, &Config.WinHeight);	
	
	g_print ("Recuperation parametre GUI\n");
	Config.BoolRadioButonGui             = gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON( GLADE_GET_OBJECT("radiobutton_gui") ));
	g_print ("Recuperation parametres dossiers\n");
	Config.BoolCheckbuttonRepPO          = gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON( GLADE_GET_OBJECT("checkbutton_dossier_po") ));
	Config.BoolCheckbuttonRepMANPAGE     = gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON( GLADE_GET_OBJECT("checkbutton_dossier_manpage") ));
	Config.BoolCheckbuttonRepLIBSTATIQUE = gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON( GLADE_GET_OBJECT("checkbutton_dossier_lib_statique") ));
	Config.BoolCheckbuttonRepPIXMAPS     = gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON( GLADE_GET_OBJECT("checkbutton_dossier_pixmaps") ));
	Config.BoolCheckbuttonRepMENU        = gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON( GLADE_GET_OBJECT("checkbutton_dossier_menu") ));
	Config.BoolCheckbuttonRepMIME        = gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON( GLADE_GET_OBJECT("checkbutton_dossier_mime") ));
	
	g_print ("Sauvegarde de la configuration\n");
	config_save ();
	
	g_print ("config_remove ()\n");
	config_remove ();
	g_print ("remove_combo ()\n");
	libcombo_remove ();
	g_print ("build_remove ()\n");
	// build_remove ();
	g_print ("Proto_remove ();\n");
	Proto_remove ();
	
	g_print ("\n");
}
// ---------------------------------------------
// StructClass->Id = window_main
// ---------------------------------------------
gboolean on_window_main_destroy_event( GtkWidget *widget, GdkEvent *event, gpointer user_data )
{
	remove_memory_apply ();
	gtk_main_quit ();
	return( FALSE );
}
gboolean on_window_main_delete_event( GtkWidget *widget, GdkEvent *event, gpointer user_data )
{
	remove_memory_apply ();
	gtk_main_quit ();
	return( FALSE );
}
void on_imagemenuitem_quit_activate( GtkImageMenuItem *menuitem, gpointer user_data )
{
	remove_memory_apply ();
	gtk_main_quit ();
}
void on_imagemenuitem_about_activate( GtkImageMenuItem *menuitem, gpointer user_data )
{
	WinAbout_open ();
}
// 
// 
gboolean on_window_main_key_press_event( GtkWidget *widget, GdkEventKey *kevent, gpointer user_data )
{
	keys.BoolGDKPress = TRUE;
	keys.keyval       = kevent->keyval;
	
	if( kevent->keyval == GDK_Control_L || kevent->keyval == GDK_Control_R ) {
		keys.BoolGDK_Control_L_R = TRUE;
	}		
	else if( kevent->keyval == GDK_Shift_L ) {
		keys.BoolGDK_Shift_L = TRUE;
	}
	else if( kevent->keyval == GDK_Shift_R ) {
		keys.BoolGDK_Shift_R = TRUE;
	}
	
	else if( kevent->state == 20 || kevent->state == 21 ) {
		if( kevent->keyval == 65 || kevent->keyval == 97 ) {
			keys.BoolGDK_Control_A = TRUE;
		}
	}
	/*
	if( NOTEBOOK_POCHETTE == Config.NotebookGeneral ) {
		if( TRUE == keys.BoolGDK_Control_L_R ) {
			pochedir_set_ctrl( TRUE );
		}
		else if( kevent->keyval == GDK_Delete) {
			// poche_remove_image();
		}
	}
	else if( NOTEBOOK_SPLIT == Config.NotebookGeneral ) {
		if( kevent->keyval == GDK_Delete ) {
			SplitSelector_cut ();
		}
		else if( kevent->keyval == GDK_space ) {
			// Une action sur la barre espace agit sur sur le play/pause
			split_play ();
		}
	}
	*/
	return FALSE;
}
// 
// 
gboolean on_window_main_key_release_event( GtkWidget *widget, GdkEventKey *kevent, gpointer user_data )
{
	keys.BoolGDKPress        = FALSE;
	keys.BoolGDK_Control_L_R = FALSE;
	keys.BoolGDK_Control_A   = FALSE;
	keys.BoolGDK_Shift_L     = FALSE;
	keys.BoolGDK_Shift_R     = FALSE;
	keys.keyval              = 0;
	/*
	if( NOTEBOOK_POCHETTE == Config.NotebookGeneral ) {
		pochedir_set_ctrl( FALSE );
	}
	*/
	return FALSE;
}
// 
// 
void AnalyseCommandLine_set_argv (int argc, gchar *argv[])
{
	gint	 i;
	
	if( optind < argc ) {
		
		for( i = optind; i < argc; i++ ) {
			// VERBOSE MODE
			if( 0 == strncmp( argv[i], "-verbose", 8 ) || 0 == strncmp( argv[i], "--verbose", 9 )) {
			    	g_print( "\nOption:\n\tVERBOSE activate\n\n" );
				OptionsCommandLine.BoolVerboseMode = TRUE;
			}
		}
	}
}

/* gint main (gint argc, gchar *argv[], gchar **envp)
 *
 * argc  designe le nombre d'arguments transmis au moment du lancement de l'executable
 * argv  designe le vecteur contenant les differents arguments
 * envp  designe le vecteur contenant les informations sur l'environnement
 */
gint main (gint argc, gchar *argv[], gchar **envp)
{
	GError	*p_err = NULL;
	gchar	*CurrentDir = g_get_current_dir ();
	gchar	*PathCurrentDir = NULL;
	gchar	*PathShareProjet = NULL;
	gchar	*Path = NULL;
	gchar	*PackageVersion = NULL;

	AnalyseCommandLine_set_argv (argc, &argv[0]);		// Get and save param-file
	
	g_print ("%s :: %s (line = %d)\n", __FILE__, __FUNCTION__, __LINE__);
	g_print ("\n");
	g_print ("***************************\n");
	g_print ("%s %s\n", PACKAGE, VERSION);
	g_print ("***************************\n");
	g_print ("%s %s compiled at %s %s\n", PACKAGE, VERSION, __DATE__, __TIME__);
	g_print ("Compiler: gcc %s\n", __VERSION__);
	g_print ("***************************\n");
	g_print ("Gtk version  = %d.%d.%d\n", GTK_MAJOR_VERSION, GTK_MICRO_VERSION, GTK_MINOR_VERSION);
	g_print ("Glib version = %d.%d.%d\n", GLIB_MAJOR_VERSION, GLIB_MICRO_VERSION, GLIB_MINOR_VERSION);
	g_print ("***************************\n\n");
#ifdef ENABLE_NLS
	g_print ("ENABLE_NLS OK\n");
	g_print ("\tGETTEXT_PACKAGE    = %s\n", GETTEXT_PACKAGE);
	g_print ("\tLOCALE_DIR         = %s\n", LOCALE_DIR);

	setlocale (LC_ALL, "");
	bindtextdomain (GETTEXT_PACKAGE, LOCALE_DIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
#else
	// g_error ("ENABLE_NLS IS NOT OK\n\n");
#endif
	config_read();
	
	gtk_set_locale ();
	gtk_init (&argc, &argv);

	if (NULL == (GtkBuilderProjet = gtk_builder_new ())) {
		return (EXIT_FAILURE);
	}
	gtk_builder_set_translation_domain (GtkBuilderProjet, NULL);

	PathCurrentDir = g_strdup_printf ("%s/glade/%s", CurrentDir, PACKAGE_NAME_GLADE);
	g_free (CurrentDir);
	CurrentDir = NULL;
	// PathShareProjet = g_strdup_printf ("%s/%s/glade/%s", DATA_DIR, PACKAGE_NAME, PACKAGE_NAME_GLADE);
	PathShareProjet = xdg_search_data_xdg( PACKAGE_NAME_GLADE );

	if (FALSE == g_file_test (PathCurrentDir, G_FILE_TEST_EXISTS) && FALSE == g_file_test (PathShareProjet, G_FILE_TEST_EXISTS)) {
		g_print("!---------------------------------------------------------------------------------------------------\n");
		g_print("! LE FICHIER XML: [ %s ] N'EXISTE PAS !!!\n", PathCurrentDir);
		g_print("!---------------------------------------------------------------------------------------------------\n");
		g_print("! LE FICHIER XML: [ %s ] N'EXISTE PAS !!!\n", PathShareProjet);
		g_print("!---------------------------------------------------------------------------------------------------\n");

		g_free (PathCurrentDir);
		PathCurrentDir = NULL;
		g_free (PathShareProjet);
		PathShareProjet = NULL;

		return (EXIT_FAILURE);
	}
	else if (TRUE == g_file_test (PathCurrentDir, G_FILE_TEST_EXISTS)) {

		Path = PathCurrentDir;
	}
	else if (TRUE == g_file_test (PathShareProjet, G_FILE_TEST_EXISTS)) {

		Path = PathShareProjet;
	}
	if( TRUE == OptionsCommandLine.BoolVerboseMode )
		g_print("\nPATHNAME FILE %s: %s\n\n", PACKAGE_NAME_GLADE, Path);
	if (gtk_builder_add_from_file (GtkBuilderProjet, Path, &p_err) <= 0) {
		g_warning ("Couldn't load builder file: %s", p_err->message);
		g_error_free (p_err);

		g_free (PathCurrentDir);
		PathCurrentDir = NULL;
		g_free (PathShareProjet);
		PathShareProjet = NULL;
		Path = NULL;

		return (EXIT_FAILURE);
	}
	g_free (PathCurrentDir);
	PathCurrentDir = NULL;
	g_free (PathShareProjet);
	PathShareProjet = NULL;
	Path = NULL;

	gtk_builder_set_translation_domain  (GtkBuilderProjet, gtk_set_locale ());
	gtk_builder_connect_signals (GtkBuilderProjet, NULL);
	WindMain = GTK_WIDGET (gtk_builder_get_object (GtkBuilderProjet, "window_main"));
	
	// REDIMENSIONNER LA FENETRE
	gtk_window_resize(GTK_WINDOW(WindMain), Config.WinWidth, Config.WinHeight);
	// PLACER LA FENETRE
	gtk_window_move(GTK_WINDOW(WindMain), Config.WinPos_X, Config.WinPos_Y);
	
	PackageVersion = g_strdup_printf ("%s %s", PACKAGE, VERSION);
	gtk_window_set_title (GTK_WINDOW (WindMain), PackageVersion);
	g_free (PackageVersion);
	PackageVersion = NULL;
	
	libutils_set_default_icone_to_win (WindMain);
	
	gtk_widget_show (WindMain);
	
	// INIT ALL PAGE NOTEBOOK
	gtk_notebook_set_current_page (GTK_NOTEBOOK (GLADE_GET_OBJECT("notebook_general")), 4 );
	gtk_notebook_set_current_page (GTK_NOTEBOOK (GLADE_GET_OBJECT("notebook_general")), 3 );
	gtk_notebook_set_current_page (GTK_NOTEBOOK (GLADE_GET_OBJECT("notebook_general")), 2 );
	gtk_notebook_set_current_page (GTK_NOTEBOOK (GLADE_GET_OBJECT("notebook_general")), 1 );
	gtk_notebook_set_current_page (GTK_NOTEBOOK (GLADE_GET_OBJECT("notebook_general")), 0 );
	gtk_notebook_set_current_page (GTK_NOTEBOOK (GLADE_GET_OBJECT("notebook_vte_glade")), 1 );
		gtk_notebook_set_current_page (GTK_NOTEBOOK (GLADE_GET_OBJECT("notebook_glade")), 1 );
		gtk_notebook_set_current_page (GTK_NOTEBOOK (GLADE_GET_OBJECT("notebook_glade")), 0 );
	gtk_notebook_set_current_page (GTK_NOTEBOOK (GLADE_GET_OBJECT("notebook_vte_glade")), 0 );
	
	Config.BoolConfigOk = TRUE;
	
	Callbacks_set_sensitive_with_gui();
	
	// ADMINISTRATOR MODE ?
	if( 0 == getuid() ) {
		wininfo_create (
			WindMain,
			_("MODE ADMINISTRATEUR"),
			  "\n",
			_("   Vous ne devriez pas utiliser   "),
			  "\n",
			_("   BASEBUILD sous ROOT !"),
			  "\n",
			"");
	}
	
	xdg_print_list_config_path();
	xdg_print_list_data_path();	
	
	gtk_main ();

	exit(EXIT_SUCCESS);
}









