 /*
 * file      : win_vte.c
 * project   : BaseBuild
 * with      : Gtk-2
 *
 * copyright : (C) 2010 - 2012 by Claude Bulin
 *
 * BaseBuild - Creation d'une base de programmation en langage C de type GNU avec les autotools
 * GNU General Public License
 * 
 * This file is part of BASEBUILD.
 * 
 * BASEBUILD is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 * 
 * BASEBUILD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with BASEBUILD.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 * status_window.c -- routines for display status information
 * This module was inspired by GRIP
 * http://nostatic.org/grip/
 * 
 */

#ifdef HAVE_CONFIG_H
	#include "../config.h"
#endif

#ifdef ENABLE_NLS
	#include <libintl.h>
	#define _(String) gettext (String)
#endif


#include <gtk/gtk.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>


#if defined(FILE_DEBIAN_VTE_H_IS_OK)
	#include <vte/vte.h>
#elif defined(FILE_ARCH_VTE_H_IS_OK)
	#include <vte-0.0/vte/vte.h>
#elif defined(FILE_FW_VTE_H_IS_OK)
	#include <vte-2.90/vte/vte.h>
#endif

#include "win_vte.h"




typedef struct {
	GtkWidget	*AdrWidget;
} VAR_VTE;

VAR_VTE	VarVte = { NULL };


// 
// WRITE a line of output to a status window
// 
void WinVte_window_write( gchar *msg )
{
	gchar	*buf;
	gsize	len;
	gint	pos = 0;

	len = strlen( msg );
	buf = (gchar *)g_malloc0(( len * 2 ) +1 );
	while( *msg ) {
		if( 1 ) {
			if( *msg == '\n' ) {
				buf[pos++] = '\r';
				buf[pos++] = '\n';
			} 
			else {
				buf[pos++]=*msg;
			}
		}
		msg++;
	}
	buf[pos] = '\0';
	vte_terminal_feed( VTE_TERMINAL(VarVte.AdrWidget), buf, strlen( buf ));
	// g_print( "%s", buf );
	g_free( buf );
	buf = NULL;
}
// PLACER DU TEXTE DANS LE TEXTVIEW
// 
void WinVte_window_write_va( gchar *p_text, ... )
{
	va_list	VaList;
	gchar	*Ptr = NULL;
	
	if( NULL != VarVte.AdrWidget ) {
		WinVte_window_write( p_text );
		va_start( VaList, p_text );
		while( NULL != ( Ptr = va_arg( VaList, gchar * ))) {
			 WinVte_window_write( Ptr );
		}
		va_end( VaList );
	}
	while (gtk_events_pending()) gtk_main_iteration();
}
// 
// VTE RESET
// 
void WinVte_reset( void )
{
	if( NULL != VarVte.AdrWidget ) {
		// vte_terminal_reset( VteTerminal *terminal, gboolean full, gboolean clear_history);
		vte_terminal_reset( VTE_TERMINAL(VarVte.AdrWidget), TRUE, TRUE );
		WinVte_window_write( "Init VTE for project generate is ok.\n" );
	}
}
// 
// REALIZE VTE
// 
void on_scrolledwindow_vte_realize( GtkWidget *widget, gpointer user_data )
{
	VarVte.AdrWidget = vte_terminal_new();
	vte_terminal_set_encoding( VTE_TERMINAL( VarVte.AdrWidget ),"UTF-8" );
	gtk_container_add (GTK_CONTAINER (widget), VarVte.AdrWidget );
	gtk_widget_show_all( widget );
	WinVte_window_write( "Init VTE for project generate is ok.\n" );
}
// 
// REALIZE VTE ?
// 
gboolean WinVte_is_ok( void )
{
	return( NULL !=	VarVte.AdrWidget ? TRUE : FALSE );
}





